



// MetaQuote [ MQ 4 ] 
#define                               IDENTIFICATION~DIVISION                                    10
// v3 




                #define   $_ProgramName         "Sub-Window TrendLine Alert"
                #define   $_SystemSymbol        "STA"
                #define   $_FileName            "Sub-Window TrendLine Alert v100 b01.mq4"
                #define   $_Author              "Keit Thomas Largo"
                #define   $_eMail               "CockeyedCowboy@hotmail.com"
                #define   $_CompanyName         "WinSoft Technology  "
                #define   $_LicenseTo           "Open Source"
                #define   $_ModuleType          "Indicator"
                #define   $_DateWriten          "12.19.2010"
                #define   $_VersionNumber       "1.20 b01 pb"
                #define   $_LastUpDate          "12.26.2010"
                #define   $_ProgramLanguage     "MetaQuote  MQL v4.00, b229"
                #define   $_ScriptLanguage      "N/A"
                #define   $_Compiler            "N/A"
                #define   $_UPXPacker           "N/A"
                #define   $_EnCryption          "N/A"
                #define   $_SecurityLevel       "N/A"
                #define   $_Documentation       "see {Documentation Division}"
                #define   $_CopyRight           "CopyRight    2010"




/*
//  COPYRIGHT NOTICE: 




                          LICENSING:   This is free, open source software,
                            licensed under Version 2 of the GNU General
                                      Public License (GPL). 

                    In particular,  this means that distribution of this soft-
                    ware in a binary format, e.g. as compiled as part of a ex4
                    file; That code must be  accompanied by the non obfuscated
                    code files of both the ex4 AND the mq4 source files it was
                    compiled with, or you must make such files available at no 
                    charge to binary recipients. If you do not agree with such
                    terms you must  not use this code.  Detailed terms  of the    
                            the GPL are widely available on the Internet.

                    This  code, in part, was derived from a publicly available
                    code entitled 'HLine Alert.mq4'. Writen by 'raff1410@o2.pl'

                                    ~~~ Keit Thomas Largo ~~~




//*/
#define                                COMPILER~DIRECTIVES                                       20
//  FILE LINKAGE: 




                    #property      copyright      "Keit Thomas Largo"
                    #property      link           "CockeyedCowboy@hotmail.com"

                    #property      indicator_separate_window
                    #property      indicator_buffers   3



//
//  LIBRARY IMPORT: 




        #import "user32.dll"
            int  MessageBoxA( int Window, string Text, string Title, int Flags );




//
#define                                ENVIRONMENT~DIVISION                                      30
//  DEFINED CONSTANT: 




                        #define             Empty               0
                        #define             Clear               ""
                        #define             AlertIcon           0x00000030
                        #define             OkButton            0x00000000




//
//  EXTERN PARAMETER: 




        extern bool
            ValueOnClose     =  False,        // True alert on close of bar, False in real time.
            CrossAbove       =  True,         // True alert on cross above, False on cross below.
            CrossStochSign   =  True,         // True will use Signal Line, False uses Main Line.
            UseRSI           =  True,         // True will use the RSI, False will use Stochastic.
            EmailON          =  True;         // True will enable Email Alerts.


        extern int
            PeriodRSI        =  4,            // Data Period for RSI,
            PecK             =  12,           // Percent K input.
            PecD             =  3,            // Percent D input.
            Smooth           =  3,            // Smoothind input.
            Method           =  1,            // Uses EMA averageing.
            Data             =  0,            // Uses High to Low moves.
            RingCount        =  2,            // Number of times sound wave will trigger.

            TrendLineStyle   =  STYLE_SOLID,  // Style of trend line.
            StochMainStyle   =  STYLE_SOLID,  // Style of stoch main line.
            StochSignStyle   =  STYLE_SOLID,  // Style of stoch signal line.
            RSILineStyle     =  STYLE_SOLID;  // Style of RSI line.


        extern color
            TrendLineColor   =  Blue,          // Color of trend line.
            StochMainColor   =  Green,         // Color of Main line index.
            StochSignColor   =  Red,           // Color of sign line index.
            RSILineColor     =  Goldenrod;     // Color of RSI line index.


        extern string
            TrendLineName    =  "TrendLine",   // Name of trend line.   CN!{script notes}:
            AlertWave        =  "alert.wav";   // Name of wave file must be in sound directory.




//
//  DEFAULT ATTRIBUTES: 




        bool
            HideDialogBox    =  False;          // True hides, False shows; Alert Dialog box.


        int
            BarStart         =  15,            // Temp trendline starting bar count.
            BarEnd           =  30,            // Temp trendline ending bar count.
            TimeDelay        =  15;            // A delay in setting line before alert activates.


        double
            Scale            =  0.10;          // Percent limit to keep line points inside window.




//
//  GLOBAL SCOPE VARIABLES: 




        int
            Window           =     Empty,      // Holds count of Sub window index.
            BarsToChart      =     Empty,      // Number of bars to calculate.
            TriggerBar       =     Empty;      // Stores bar trigger, see 'ValueOnClose'


        double
            AlertValue       =     Empty,      // Holds the current trigger value.
            EndAt            =     Empty,      // Ending point of temp trend line.
            StartAt          =     Empty,      // Starting point of temp trend line.
            IndexValue       =     Empty,      // The buffer value of trip bar.
            Maximum          =     Empty;      // Holds the maximum Window scale.


        string
            TrendLineID      =     Clear;      // Holds trendline object unique nameing. 


        datetime
            HoldTime         =     Empty;      // Holds the trigger delay time.




//
//  GLOBAL SCOPE ARRAYS: 



            double
                StochMain       [ ],            // Stochastic Main Line,     0 Buffer.
                StochSign       [ ],            // Stochastic Signal Line,   1 Buffer.
                RSI             [ ];            // Relative Strength Index,  2 Buffer.




//
#define                               CONFIGURATION~DIVISION                                     40
void init(){//




        TimeDelay    =  MathMin( MathMax( TimeDelay, 0 ), 60 ); 
        RingCount    =  MathMin( MathMax( RingCount, 1 ), 20 ); 
        HoldTime     =  TimeLocal() + TimeDelay;
        TrendLineID  =  DoubleToStr( $_GetNumberID(), 0 ) + TrendLineName;


        IndicatorShortName( $_ProgramName );
        IndicatorBuffers  ( 3 );


        SetIndexBuffer( 0, StochMain );
        SetIndexLabel ( 0, "Stochastic Main Line" );
        SetIndexStyle ( 0, DRAW_LINE, StochMainStyle, 1, StochMainColor );

        SetIndexBuffer( 1, StochSign );
        SetIndexLabel ( 1, "Stochastic Signal Line" );
        SetIndexStyle ( 1, DRAW_LINE, StochSignStyle, 1, StochSignColor );

        SetIndexBuffer( 2, RSI );
        SetIndexLabel ( 2, "RSI Indicator Line" );
        SetIndexStyle ( 2, DRAW_LINE, RSILineStyle, 1, RSILineColor );




return;}//
#define                                   CODING~DIVISION                                        50
void start(){//




        BarsToChart  =  Bars - IndicatorCounted() + 1 ;
        Window       =  WindowOnDropped();
        Maximum      =  WindowPriceMax( Window );
        StartAt      =  Maximum * ( 1 - Scale );
        EndAt        =  ( Maximum - WindowPriceMin( Window )) * Scale;
        TriggerBar   =  IFF( ValueOnClose, 1, 0 );
        IndexValue   =  IFF( CrossStochSign, StochSign[ TriggerBar ], StochMain[ TriggerBar ] );
        IndexValue   =  IFF( UseRSI, RSI[ TriggerBar ], IndexValue );


        CreateData( UseRSI, RSI, StochMain, StochSign, BarsToChart );
            if( StartAt <= 0 )   {   return;   }  //  CN!{script notes}:

        CreateLine( TrendLineID, Window, StartAt, EndAt, TrendLineColor, TrendLineStyle );
            if( ObjectGet( TrendLineID, 3 ) == StartAt )   {   return;   }  //  CN!{script notes}:

        AlertValue  =  ObjectGetValueByShift( TrendLineID, TriggerBar );




//
#define                                   OUTPUT~DIVISION                                        60
//




        AlertStatus( IndexValue, AlertValue, CrossAbove, AlertWave, RingCount );




return;}//
#define                                TERMINATION~DIVISION                                      70
void deinit(){//




            ObjectDelete( TrendLineID );




return;}//
#define                           PROCEDURAL~DEFINITION~DIVISION                                 80
//  OBJECT PROPERTIES: 




//
//  FUNCTION PROCEDURES: 




/*===============================================================================================|\
||                                                                                               ||
||        $_GetNumberID Function Procedure        v2.70        Date 02.23.2007       KTL         ||
||                                                                                               ||
||  Returns:     An 'int type' three digit number from 101 to 999.                               ||
||                                                                                               ||
||  Purpose:     To give each chart/indicator its own, unique object identification number. To   ||
||               prevent any program code from interferring with any other objects, globals,     ||
||               orders etc., that may co-exist along side its.                                  ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
int
    $_GetNumberID() {
        int PullNumber      =  101;

            if( GlobalVariableCheck( "PullNumber ( Do Not Delete )" ))
                PullNumber  =  GlobalVariableGet( "PullNumber ( Do Not Delete )" );

            GlobalVariableSet( "PullNumber ( Do Not Delete )", PullNumber + 1 );

            if( GlobalVariableGet( "PullNumber ( Do Not Delete )" ) > 999 )
                GlobalVariableSet( "PullNumber ( Do Not Delete )", 101 );

    return( PullNumber );
} // End Function Procedure, $_GetNumberID:




/*===============================================================================================|\
||                                                                                               ||
||  StringToUpperCase Function Procedure          v2.00         Date 04.12.2010           KTL    ||
||                                                                                               ||
||  Returns:     The string past it converted intp upper case.                                   ||
||                                                                                               ||
||  Purpose:     To get a string of mixed case to upper case. This will not handle any other     ||
||               numbers or symbol characters.                                                   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
string
    StringToUpperCase( string InString ) {
        int    Index      =  Empty;
        int    Character  =  Empty;
        int    Length     =  StringLen( InString );
        string OutString  =  Clear;

            for( Index = 0; Index < Length; Index ++ ) {
                Character  =  StringGetChar( InString, Index );

                if( Character >= 97 && Character <= 122 )
                    Character  =  Character - 32;

                OutString  =  OutString + CharToStr( Character );

            } // End For Loop, Index:

    return( OutString );
} // End Function Procedure, StringToUpperCase:




/*===============================================================================================|\
||                                                                                               ||
||  Filler Function Procedure              v1.00             Date 04.07.2008               KTL   ||
||                                                                                               ||
||  Returns:     Returns a string of repeating characters.                                       ||
||                                                                                               ||
||  Purpose:     Used in either printing to logs or graphic user interface outputs.              ||
||                                                                                               ||
||  Parameters:  Count -- Number of repeating character. Default is one.                         ||
||               Type  -- The character that will be repeated. Default is a space.               ||
||                                                                                               ||
||  Note:        Count  =  MathMax( MathAbs( Count ), 1 )); Line is to eleminate negitive and    ||
||               zero imputs.                                                                    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
string
    Filler( int Count = 1, string Tpye = " " ) {
        int      Loop        =   Empty;
        string   OutString   =   Clear;

            Count  =  MathMax( MathAbs( Count ), 1 );

            for( Loop = 1; Loop <= Count; Loop ++ )
                OutString  =  OutString + Tpye;

    return( OutString );
} // End Function Procedure, Filler:




/*===============================================================================================|\
||                                                                                               ||
||  IFF Function Procedure              v1.01             Date 06.20.2010               KTL      ||
||                                                                                               ||
||  Returns:     Returns the TrueCondition if the Expression is True, else it will return the    ||
||               FalseCondition.                                                                 ||
||                                                                                               ||
||  Purpose:     this is an evaluation statement that test the expression for true of false and  ||
||               returns the approperate conditional statement.                                  ||
||                                                                                               ||
||  Note:        False is the default return even if an error is encountered.                    ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
double
    IFF( bool Expression, double TrueCondition, double FalseCondition ) {
        double ReturnValue   =   FalseCondition;

            if( Expression )   {   ReturnValue  =  TrueCondition;   }

    return( ReturnValue );
} // End Function Procedure, IFF:




/*===============================================================================================|\
||                                                                                               ||
||  IFFtrue Function Procedure              v1.01             Date 07.22.2010              KTL   ||
||                                                                                               ||
||  Returns:     Returns the string of the condition of the expression.                          ||
||                                                                                               ||
||  Purpose:     To get a string respones to a true false condition.                             ||
||                                                                                               ||
||  Note:        Example;                                                                        ||
||                  ConnectionStatus  =  IfTRUE( IsConnected(), "ON LINE", "OFF LINE" );         ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
string
    IFFtrue( bool Expression, string TrueCondition, string FalseCondition ) {
        string ReturnValue   =   " ERROR ";

            if( Expression )   {   ReturnValue  =  TrueCondition;   }
            else               {   ReturnValue  =  FalseCondition;  }

    return( ReturnValue );
} // End Function Procedure, IFFtrue:




//
//  ROUTINE PROCEDURES: 




/*===============================================================================================|\
||                                                                                               ||
||  CreateLine Routine Procedure             v1.01               Date 12.19.2010          KTL    ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Draws the initial trend line in the given subwindow. It will not redraw/ move   ||
||               the trend line back if the user moves it, but will redraw the line if the user  ||
||               were to delete it.                                                              ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    CreateLine( string Name, int SubWindow, double Start, double End, color Color, int Style ) {

        if( ! ObjectFind( Name) == SubWindow ) {
            ObjectCreate ( Name, OBJ_TREND, SubWindow, Time[  BarEnd  ], End,
                                                       Time[ BarStart ], Start );

                ObjectSet( Name, OBJPROP_STYLE, Style );
                ObjectSet( Name, OBJPROP_COLOR, Color );

        } // End If, ObjectFind:

    return;
} // End Routine Procedure, CreateLine:




/*===============================================================================================|\
||                                                                                               ||
||  CreateData Routine Procedure             v1.11            Date 12.23.2010             KTL    ||
||                                                                                               ||
||  Returns:     The data buffers filled with the given indicator.                               ||
||                                                                                               ||
||  Purpose:     This porcedure is were the buffer is filled. we can use any built in indacators ||
||               or a custom indicator.                                                          ||
||                                                                                               ||
||  Parameters:  Array    -- This is the indicator buffer that is drawn, passed by reference.    ||
||               BarCount -- This is basicly the IndicatorCounted() routine for drawing buffers. ||
||                                                                                               ||
||  Note:        This code is done useing the Stochastic indicator. If any other indicator is to ||
||               be used the  Array[Index]  =, Line will need to be re-placed with what ever     ||
||               indicator one wants including useing a call to the iCustom() function for       ||
||               custom indicators.                                                              ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    CreateData( bool ShowRSI, double& Relative[], double& Main[], double& Sign[], int BarChart ) {
        int   Index   =   Empty;

        if( ShowRSI )
            for( Index = 0; Index <= BarChart; Index ++ )
                RSI [ Index ]  =  iRSI( NULL, 0, PeriodRSI, PRICE_CLOSE, Index );

        else
            for( Index = 0; Index <= BarChart; Index ++ ) {
                Main[ Index ]  =  iStochastic( NULL, 0, PecK, PecD, Smooth, Method, Data, 0, Index );
                Sign[ Index ]  =  iStochastic( NULL, 0, PecK, PecD, Smooth, Method, Data, 1, Index );

            } // End For Loop, Index:

    return;
} // End Routine Procedure, CreateData:




/*===============================================================================================|\
||                                                                                               ||
||  AlertStatus Routine Procedure           v1.01            Date 12.19.2010             KTL     ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Triggers the alert sound wave and calls to display dialog box.                  ||
||                                                                                               ||
||  Note:        This alert will ring the give number of times and stop. If you move the trend   ||
||               that will reset the counter and if the data line crosses again it will resound. ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    AlertStatus( double LineValue, double Value, bool Above, string Wave, int Count ) {
        static bool     NoticeShown   =   False;
        static int      HoldCount     =   Empty;
        static double   HoldValue     =   Empty;
        double          TriggerLine   =   Empty;

            HoldCount    =  IFF( HoldValue == Value, HoldCount, 0 );
            NoticeShown  =  IFF( HoldCount == Empty, False, True );
            HoldTime     =  IFF( HoldCount >= Count, TimeLocal() + TimeDelay, HoldTime );
            HoldValue    =  Value;

                if( TimeLocal() < HoldTime || HoldCount >= Count ) return;

                if( Above )
                    if( LineValue > Value ) {
                        PlaySound( Wave );
                        HoldCount ++;
                        DisPlayNotice( NoticeShown, Above );
                        if (EmailON) SendMail("Alert ", "Exit Trade, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());

                    } // End If, LineValue:

                if( ! Above )
                    if( LineValue < Value ) {
                        PlaySound( Wave );
                        HoldCount ++;
                        DisPlayNotice( NoticeShown, Above );
                        if (EmailON) SendMail("Alert ", "Exit Trade, Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());

                    } // End If, LineValue:

    return;
} // End Routine Procedure, AlertStatus:




//
//  GRAPHIC INTERFACE: 




/*===============================================================================================|\
||                                                                                               ||
||  DisPlayNotice GUI Procedure              v1.03             Date 12.19.2010          KTL      ||
||                                                                                               ||
||  Returns:     Returns NoticeShown as it was pasted by referance.                              ||
||                                                                                               ||
||  Purpose:     To inform user that this indicator data line crossed the trend line.            ||
||                                                                                               ||
||  Parameters:  NoticeDone -- is the flag to indicate when the notice box has been shown. It    ||
||                             will be shown only once per alert, no matter how meny times you   ||
||                             you have the sound alert play.                                    ||
||                                                                                               ||
||  Note:        This dialog box will show up only once on each alert not each time the alert is ||
||               sounded. The box will stay on the screen till the user hits the OK buttom. The  ||
||               the purpose here is to have a visual notice that the alert was sent in case     ||
||               one is not arround to hear the alert. A switch was added 'HideDialogBox' to     ||
||               turn this off if one doesnot like the way it function. CN!{see script notes}:   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
void
    DisPlayNotice( bool& NoticeDone, bool Cross ) {
        int    Respond     =   Empty;
        int    WindowID    =   WindowHandle( Symbol(), Period());
        string System      =   StringToUpperCase( $_ProgramName );
        string Direction   =   IFFtrue( Cross, "Above", "Below" );
        string Screen      =   $_CompanyName + Filler( 25 ) + "INDICATOR  CROSS  TRENDLINE";

            if( HideDialogBox || NoticeDone ) return;

            MessageBoxA( WindowID, "\n" +
                Filler( 35 ) + "ALERT  NOTICE: \n\n" +
                Filler( 20 ) + "\"" + System + "\"\n\n" +
                Filler( 5 )  + "The Indicator Data Line Has Crossed " +
                               Direction + " Its Trend Line.\n" +
                Filler( 10 ) + "The Cross " + Direction + ", Occoured At:  " +
                               TimeToStr( TimeCurrent( ), TIME_MINUTES ) +
                               "  Broker Time.",

                Screen, OkButton | AlertIcon );

                NoticeDone  =  True;

    return;
} // End GUI Procedure, DisPlayNotice:




//
#define                                DOCUMENTATION~DIVISION                                    90
/*  PURPOSE AND SCOPE: 




    The purpose of this code was to run basic tests on; A) the reaction of trend lines 
    functioning within sub windows, and, B) to test the effects of the MessageBox() function
    on an indicator code.

    Being test code, its use has little if any benefit in trading. as I have little use of
    typical indicators.





  FUNCTION OF INDICATOR: 




    This needs dll to be turned on for the message box to work.


    Trend line will not draw untill the window has been scaled. which when appling the indicator
    to the chart for the first time it will take 2 incoming ticks to set the scale, as a result
    the trend line may take a few seconds to show. There-after when making changes in the dialog
    box etc.. The tendline will be draw instancely.


    This trend line can be used as either a vertical or horizontal alert line as well as in its
    typical style.


    The alert trigger will activate only once even in real time that is if the data line crosses
    the trend line and goes back under it. it will trigger only once the first time it crosses.
    If it goes under it and recrosses it will not trigger the second time. To reset the trigger
    you must move the trend line even if you put it back in the same place it will reset. When
    the trend line is first drawn in its default location the alert will not trigger untill you
    move the line that will active the alerts function. When moving the trend line as in manually
    draging it accross the data line it will not trigger emeandiately as there is a delay set
    so the trigger will not get in the way when your tring to move the line, if you want to have
    the trigger to go off by simply dragging it accross the data line then set 'TimeDelay'
    parameter in the DEFAULT ATTRIBUTES: section to zero. This will turn off the delay. The
    default is set to 30 which is in seconds and the largest delay is 60 seconds. Over that
    we would miss movement on the one minute bar.


    This code is hard coded with the built in iStochastic() indicator, parameter for it can
    be changed with-in the DEFAULT ATTRIBUTES: section. Also if one wants these parameters
    to be exposed as external all one has to do is add the keyword 'extern' above the type
    declarations.

    You can not have a trend line on an indicator if its data is not made available with in
    the trend line code. That is you can not simply add a trend line to an indicator window
    that contains the indicator as the data can not be read by the trendline. 

        CreateData( );
    If one wants to change the indicator from the stochastic, it can be done within the above
    function. This can be done easily by hard coding in a different builtin indicator or a
    custom indictor with the use of the iCustom() function. This can be done by any one with
    just a little experance.


    Other prarmeters that may need explaining are;

        ValueOnClose  =  False;
    This setting will set the alert function to trigger at the close of the bar on which the
    cross occured. Therefore, any crosses in real time will not trigger if at the close the 
    data line crosse back. This is to alert you only when it is crossed and will not change. 


        CrossAbove  =  True;
    This parameter tells the alert function if you want an alert when the data line crosses
    Above the trend line. When set to False, it will reverse the alert to indicate when the
    data line crosses Below the trend line.


        RingCount  =  2;
    This parameter sets the number of times you want the alert sound wave to play, defalt is
    two. but you can set it to any number you want up to 20. Remember that a high number can
    be real pain. The sounds are tick based so there is no set time between them it will
    depend on incoming ticks to set it off. They can be fast or real slow. Also no matter
    what this variable is set to it can not be smaller then 1 or higher then 20. Numbers
    out side of this boundary will default to its nearest limit. 

    The alert box will show up only once on an alert trigger not matter what RingCount is 
    set too. If you ckick the ok buttom but the RingCount has not completed yet it will not
    display the box again untill the trend line is reset by moving it to a new location.


        HideDialogBox  =  False;
    This is explained in the Script Notes: section below.





  FILES DISCRIPTIONS: 





  TESTING AND DEBUGING: 





  VERSION UPDATES: 




        Current Revisions:
            Version 1.00 b01 pb     12.19.2010
                *	First public bata release.

            Version 1.10 b01 pb     12.23.2010
                *   Added imputs to change the stochastic indicator settings.

            Version 1.20 b01 pb     12.26.2010
                *   Added a switch to change the indicator from the stochastic
                    to the RSI indicator.



        Future Enhancement:
                - 	None





  SCRIPT NOTES: 



        TrendLineName  =  "TrendLine"
    The above user external input that discribes the trend line name need not be changed even
    if one has more then one copy of the program running as each copy has a unique ID attach
    to the name that makes them different in all copies. There for changes to this parameter
    is not needed.



        HoldTime  =  Empty;
    This variable was added to give the user time to move the trendline with out fear of setting
    off the alert function. It applies a small delay when moving the trend line before the alert
    actives. The dely is set in the DEFAULT ATTRIBUTES: section with the parameter 'TimeDelay'
    which is set to 30 seconds.



        if( StartAt <= 0 )   {   return;   }
    The above line of code was added to stop the trend line from drawing untill the sub window
    its attached to has been scaled. MT takes 1 more tick to scale the window after the data
    buffer has been created. This line holds the trend line back till it sees the window scale.



        if( ObjectGet( TrendLineID, 3 ) == StartAt ) return;
    The above line of code was added to stop the alert from triggering on the default trend line.
    The alert functions are idle untill you move the the trend line from its tempary default
    location.



        HideDialogBox    =  False;
    The Switch 'HideDialogBox' was added to the DEFAULT ATTRIBUTES: section of code to turn off
    the call to 'DisPlayNotice' dialog box as it causes some mouse malfunctions at times which
    one may not like. MT says " The message box function cannot be called from custom indicators
    since they are executed within interface thread and may not decelerate it". I wanted to see 
    how it operated within an indicator as this was a test code. The results are that one can
    call the message box function from an indicator, but the code doesnot stop for a reply from 
    the user like it dose in an EA or script file. There fore the best use for it in an indicator
    is as a alert notice with no user input except to cancel it with the ok buttom. The box will
    remain on the screen till it is cancelled but it will have no real effect on the indicator. 





  CODE STORAGE: 




/*===============================================================================================|\
||                                                                                               ||
||  Public Private Function Routine GUI Procedure Property    v1.01    Date 00.00.2010     KTL   ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     None.                                                                           ||
||                                                                                               ||
||  Parameters:  None.                                                                           ||
||                                                                                               ||
||  Note:        None.                                                                           ||
||                                                                                               ||
||  Example:     None.                                                                           ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/




//*/
#define                                 END~PROGRAM~SCRIPT~[mq4]                                 00
// [ v3.rev.01-01-2010] 







